% Negation
non_member(X, [Y|Ys]) :- X \= Y, non_member(X, Ys).
non_member(X, []).

% De-duplicate a list
no_doubles([X|Xs], [Y|Ys]) :-  member(X, Xs), no_doubles(Xs, Ys).
no_doubles([X|Xs], [X|Ys]) :- non_member(X, Xs), no_doubles(Xs, Ys).
no_doubles([], []).

% Binary trees
binary_tree(void).
binary_tree(tree(Element, Left, Right)) :- binary_tree(Left), binary_tree(Right).

tree_member(X, tree(X, Left, Right)).
tree_member(X, tree(Y, Left, Right)) :- tree_member(X, Left).
tree_member(X, tree(Y, Left, Right)) :- tree_member(X, Right).

% Are two trees isomorphic?
isotree(void, void).
isotree(tree(X, Left1, Right1), tree(X, Left2, Right2)) :- isotree(Left1, Left2), isotree(Right1, Right2).
isotree(tree(X, Left1, Right1), tree(X, Left2, Right2)) :- isotree(Left1, Right2), isotree(Right1, Left2).

% Pre-order traversal of a binary tree.
pre_order(tree(X, L, R), Xs) :- pre_order(L, Ls), pre_order(R, Rs), append([X|Ls], Rs, Xs).
pre_order(void, []).

% List substitution. 
substitute(X, Y, [], []).
substitute(X, Y, [X|Xs], [Y|Ys]) :- substitute(X, Y, Xs, Ys).
substitute(X, Y, [Z|Xs], [Z|Ys]):- X \= Z, substitute(X, Y, Xs, Ys).
